;+
; NAME: ccsds_interface__open_for_reading.pro
;
; PURPOSE: Open a binary packet file for reading
;
; CATEGORY: Engineering
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

;pro ccsds_interface::trace, msg
;  if self.verbose then print, '((( ' + msg + ' )))'
;end

; Open a file for reading. No error checking yet.
function ccsds_interface::open_for_reading, fname
;  print, 'ccsds_interface::open_for_reading'
  self->trace, 'ccsds_interface::open_for_reading'
  openr, file_unit, fname, /get_lun, error=err
  if err ne 0 then return, 0  ; Set error here
  self.file_unit = file_unit
  self->set_file_name, fname
  self->clear_errors
;  fs = fstat(file_unit)
;  print, 'FS.SIZE = ', fs.size
  return, 1
end
