;+
; NAME: ccsds_writer__define.pro
;
; PURPOSE: Definition of the EIS ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

; Open a file for writing. No error checking yet.
function ccsds_interface::open_for_writing, fname
  print, 'ccsds_writer::open_for_writing'
  openw, file_unit, fname, /get_lun, error=err
  if err ne 0 then begin
     self.error = err
     return, 0
  endif
  self.file_unit = file_unit
  self->set_file_name, fname
  self.error = 0
  return, 1
end
