;+
; NAME: ccsds_packet__define.pro
;
; PURPOSE: Definition of the general ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

function ccsds_packet::INIT, debug=debug, trace=trace
  COMPILE_OPT IDL2
  foo = self->base_object::INIT(trace=trace)
  if keyword_set(trace) then self->trace_on
;  print, 'ccsds_packet::INIT'
  self->trace, 'ccsds_packet::INIT'
  if keyword_set(debug) then self.debug = 1
  self.primary_hdr_len = 6
  self.has_secondary_hdr = 1
  self.secondary_hdr_len = 4
  ;self.primary_hdr_len = ccsds_constants.primary_header_length
  ;self.primary_hdr_len = ccsds_constants.primary_header_length()
  self.endian = 'big'
  return, 1
end
