;+
; NAME: eis_gap_ccsds_reader__define.pro
;
; PURPOSE: Definition of the EIS ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

;function eis_gap_ccsds_reader::calculate_number_missing, seq_count, next_seq_count
;  if seq_count gt next_seq_count then return, seq_count - next_seq_count
;  return, seq_count + '8000' - next_seq_count
;  return, 1
;end

;function eis_gap_ccsds_reader::read_ccsds_header, keep=keep
;  lu  = self.file_unit
;  error = self->read_ccsds_packet_header(lu)
;  if error then return, 0
;  if keyword_set(keep) then begin
;    self.first_ccsds_header = hdr
;    self.previous_seq_count = seq_count
;    print, 'read_ccsds_header : KEEPING'
;    self->print_sequence_count
;    return, 1
;  endif
;end

; function eis_gap_ccsds_reader::next_packet, packet, with_apid=with_apid
;   ;;;print, 'eis_ccsds_reader::next_packet'
;   lu = self.file_unit
;   error = self->read_ccsds_packet(lu, packet, with_apid=with_apid)
;   ;packet = [self.ccsds_header, self.ccsds_payload]
;   ;print, 'eis_ccsds_reader::next_packet : error = ', error
;   return, error
;   ;return, self->eis_ccsds_interface::next_packet(lu, packet, with_apid=with_apid)
; end
;;   if KEYWORD_SET(with_apid) then begin
;;     ;print, 'Looking for 0x' + strtrim(string(with_apid, format='(Z04)'))
;;     more = 1
;;     while (more) do begin
;;       if self->read_next_packet(buffer) then begin
;;         ;print, 'APID = 0x' + strtrim(string(self->get_apid(), format = '(Z04)'), 2)
;;         if self->get_apid() eq with_apid then begin
;;           packet = [self.ccsds_header, buffer]
;;           ;print, 'Found packet'
;;           return, 1
;;         endif
;;       endif else begin
;;         ;print, 'Not right packet'
;;         return, 0
;;       endelse
;;     endwhile
;;   endif else begin
;;     if self->read_next_packet(buffer) then begin
;;     ;if self->read_ccsds_header() then begin
;;     ;  self->read_user_data, buffer
;;       packet = [self.ccsds_header, buffer]
;;       return, 1
;;     endif else begin
;;       return, 0
;;     endelse
;;   endelse
;; end


;function eis_gap_ccsds_reader::missing_packet_count
;  return, self.missing_packet_count
;end

;function eis_gap_ccsds_reader::ngaps
;  return, self.ngaps
;end

;function eis_gap_ccsds_reader::missing_packets
;  return, self.missing_packets
;end

;pro eis_gap_ccsds_reader::clear_errors
;  self->eis_ccsds_interface::clear_errors
;end

;pro eis_gap_ccsds_reader::clear_counters
;  self.missing_packets_count = 0
;  self.ngaps = 0
;  self.missing_packets = 0
;end

;pro eis_gap_ccsds_reader::debug
;  print, 'eis_gap_ccsds_reader::debug'
;  self->eis_ccsds_reader::debug
;  prefix = 'eis_gap_ccsds_reader.'
;  print, prefix + 'missing_packet_count : ', self.missing_packet_count
;  print, prefix + 'gaps                 : ', self.gaps
;  print, prefix + 'missing_packets      : ', self.missing_packets
;end

;pro eis_gap_ccsds_reader::initialise
;  self->eis_ccsds_reader::initialise
;  self->clear_errors
;  self->clear_counters
;end
;function eis_gap_ccsds_reader::INIT
;  self->eis_ccsds_reader::initialise
;  self->clear_errors
;  self->clear_counters
;  return, 1
;end

pro eis_gap_ccsds_reader__define
  print, 'eis_gap_ccsds_reader__define'
  struct = { eis_gap_ccsds_reader,       $
             missing_packets_count : 0L, $
             ngaps                 : 0L, $
             missing_packets       : 0,  $ ; missing packets detected
             inherits eis_ccsds_reader }

end
